#!/bin/sh

REL=13.1

if [ "$1" = "" ] || ( \
[ ! "$1" = "i386" ] && [ ! "$1" = "i386smp" ] && [ ! "$1" = "i386BOOT" ] && \
[ ! "$1" = "i586" ] && [ ! "$1" = "i586smp" ] && \
[ ! "$1" = "i686" ] && [ ! "$1" = "i686smp" ] ); then
  echo usage:
#  echo sh $0 i386\|i386smp\|i686\|i686smp
  echo sh $0 i386\|i386smp\|i386BOOT
  exit 0
fi

TYPE=`echo $1 | grep smp`
if [ ! "$TYPE" = "" ]; then 
  TYPE=smp
fi
if [ ! "$TYPE" = "smp" ]; then
  TYPE=`echo $1 | grep BOOT`
  if [ ! "$TYPE" = "" ]; then
    TYPE=BOOT
  fi
fi

cd /usr/src/linux
cp -af configs/kernel-*-$REL$TYPE-i386.config arch/i386/defconfig
rm -f .config
perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -$REL$TYPE/" Makefile
CPUNUM=1
if [ -x /usr/bin/getconf ]; then
  CPUNUM=`/usr/bin/getconf _NPROCESSORS_ONLN`
  if [ $CPUNUM -eq 0 ] ; then
    CPUNUM=1
  fi
fi
if [ ! "$CPUNUM" = "1" ]; then
  perl -p -i -e "s/^MAKE\t=.*/MAKE\t=make -j$CPUNUM/" Makefile
fi
make mrproper
make oldconfig
make dep
make include/linux/version.h

echo Done...
