/*
 *  You MUST edit this file to set up the Base IO address and IRQ
 *  of your modem.
 */

#define CLM_BASE_IO_ADDRESS	0xde00
#define CLM_IRQ			10

/* Comment this if the driver doesn't detect your PCI modem */
#define DETECT_PCI_MODEM

/* Comment this if you want V.32Bis back */
#define V34

#define WAIT_FOR_DIALTONE_TIME	4	/* seconds */
#define WAIT_FOR_ANSWER_TIME	10	/* seconds */
#define WAIT_FOR_CARRIER_TIME	20	/* seconds */

/* #define DEBUG */
#define SHOW_MESSAGES

#ifdef DEBUG
#define Dbg(m...) printk(KERN_DEBUG ## m)
#else
#define Dbg(m...)
#endif

#ifdef SHOW_MESSAGES
#define Msg(m...) printk(KERN_INFO ## m)
#else
#define Msg(m...)
#endif


#ifndef CLM_BASE_IO_ADDRESS
#error "You must configure the Base IO Address"
#endif

#ifndef CLM_IRQ
#error "You must configure the IRQ number"
#endif
