
#define TONE_DIALING		0
#define PULSE_DIALING		1

#define DTMF_DIALING_SPEED	70	/* Default 70 ms */
#define PULSE_MAKE_TIME		39	/* 39 % */	/* 33 % for the UK */
#define PULSE_BREAK_TIME	61	/* 61 % */	/* 67 % for the UK */

#define SPKR_OFF		0
#define SPKR_ON			1

#define VOL_LOW			1
#define VOL_MEDIUM		2
#define VOL_HIGH		3

#define COMMON_PATCH		1
#define DATA_PATCH		2
#define TRAINING_PATCH		3
#define TRAINING_PATCH2		4
#define VOICE_PATCH		5
#define VOICE_PATCH2		6

#define CP_INIT			0
#define CP_WAIT_FOR_DIALTONE	1
#define CP_WAIT_FOR_ANSWER	2

#define C_DIALTONE_DETECTED	1
#define C_RING_START		2
#define C_BUSY_DETECTED		3
#define C_NO_DIALTONE		4
#define C_ANSWER_X		5
#define C_ANSWER_DETECTED	6
#define C_RING_END		7

#define M_NO_CONNECTED		0
#define M_HANDSHAKING		1
#define M_CONNECTED		2
#define M_RETRAINING		3
#define M_DROP			4
#define M_RETRAINING_X		13

#define TL_TONE			0
#define TL_DATA			2
#define TL_FAX			3
#define TL_VOICE		4

#define M_CONN_ANSW		0
#define M_CONN_ORIG		1

#define MD_V21			0x2
#define MD_V23_A		0x4
#define MD_V23_B		0x5
#define MD_V22			0x6
#define MD_V22BIS		0x7
#define MD_V32			0xc
#define MD_V32_QAM		0xd
#define MD_V32BIS		0x10
#define MD_V34_SYMM		0x11
#define MD_V34_ASYM		0x12
#define MD_V34			0x12
#define MD_VX2			0x16
#define MD_V90			0x17

#define BR_300			0x2
#define BR_1200			0x3
#define BR_2400			0x4
#define BR_4800			0x5
#define BR_7200			0x6
#define BR_9600			0x7
#define BR_12000		0x8
#define BR_14400		0x9
#define BR_16800		0xa
#define BR_19200		0xb
#define BR_21600		0x10
#define BR_24000		0x11
#define BR_26400		0x12
#define BR_28800		0x13
#define BR_32100		0x14
#define BR_33600		0x15

int init_modem(void);
void reset_modem(void);
int wait_for_dialtone(void);
void dial_number(int dialing_type, char *phone);
int wait_for_answer(void);
int orig_modem_connection(void);
int wait_for_carrier(void);
void end_connection(void);
