/*****************************************************************************
 *****************************************************************************

 Copyright (c) 1999 - 2001, Intel Corporation 

 All rights reserved.

 Redistribution and use in source and binary forms, with or without 
 modification, are permitted provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice, 
     this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright notice,
     this list of conditions and the following disclaimer in the documentation 
     and/or other materials provided with the distribution.

  3. Neither the name of Intel Corporation nor the names of its contributors 
     may be used to endorse or promote products derived from this software 
     without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 

 *****************************************************************************
 *****************************************************************************/

/*************************************************************************/
/*! \file   e1000.h
 *  \author Intel Corporation
 *  \date   1999 - 2001
 *  \brief  Linux PRO/1000 Ethernet Driver main header file
 *************************************************************************/

#ifndef _E1000_H_
#define _E1000_H_

struct _ADAPTER_STRUCT;
typedef struct _ADAPTER_STRUCT ADAPTER_STRUCT, *PADAPTER_STRUCT;

#include <linux/config.h>
#include "e1000_kcompat.h"
#include <linux/module.h>
#include <linux/types.h>
#include <asm/byteorder.h>

/* Prevent name space polution */
/* fxhw.c */
#define AdapterStop e1000_AdapterStop
#define InitializeHardware e1000_InitializeHardware
#define InitRxAddresses e1000_InitRxAddresses
#define SetupFlowControlAndLink e1000_SetupFlowControlAndLink
#define SetupPcsLink e1000_SetupPcsLink
#define ConfigFlowControlAfterLinkUp e1000_ConfigFlowControlAfterLinkUp
#define ForceMacFlowControlSetting e1000_ForceMacFlowControlSetting
#define CheckForLink e1000_CheckForLink
#define ClearHwStatsCounters e1000_ClearHwStatsCounters
#define GetSpeedAndDuplex e1000_GetSpeedAndDuplex
#define ReadEepromWord e1000_ReadEepromWord
#define WriteEepromWord e1000_WriteEepromWord
#define ValidateEepromChecksum e1000_ValidateEepromChecksum
#define UpdateEepromChecksum e1000_UpdateEepromChecksum
#define WriteEepromChecksum e1000_WriteEepromChecksum
#define ReadPartNumber e1000_ReadPartNumber
#define IdLedOn e1000_IdLedOn
#define IdLedOff e1000_IdLedOff
/* phy.c */
#define ReadPhyRegister e1000_ReadPhyRegister
#define WritePhyRegister e1000_WritePhyRegister
#define PhyHardwareReset e1000_PhyHardwareReset
#define PhyReset e1000_PhyReset
#define PhySetup e1000_PhySetup
#define ASDEConfigureMacToPhySettings e1000_ASDEConfigureMacToPhySettings
#define ConfigureMacToPhySettings e1000_ConfigureMacToPhySettings
#define DisplayMiiContents e1000_DisplayMiiContents
#define AutoDetectGigabitPhy e1000_AutoDetectGigabitPhy
#define PxnPhyResetDsp e1000_PxnPhyResetDsp
/* iANS */
#define bd_ans_ActivateFastPolling e1000_ans_ActivateFastPolling
#define bd_ans_AttributeFill e1000_ans_AttributeFill
#define bd_ans_DeActivateFastPolling e1000_ans_DeActivateFastPolling
#define bd_ans_Disconnect e1000_ans_Disconnect
#define bd_ans_ExtendedGetCapability e1000_ans_ExtendedGetCapability
#define bd_ans_ExtendedGetStatus e1000_ans_ExtendedGetStatus
#define bd_ans_ExtendedSetMode e1000_ans_ExtendedSetMode
#define bd_ans_ExtendedStopPromiscuousMode e1000_ans_ExtendedStopPromiscuousMode
#define bd_ans_ExtractValue e1000_ans_ExtractValue
#define bd_ans_FillStatus e1000_ans_FillStatus
#define bd_ans_GetAllCapabilities e1000_ans_GetAllCapabilities
#define bd_ans_GetVlanId e1000_ans_GetVlanId
#define bd_ans_Identify e1000_ans_Identify
#define bd_ans_Init e1000_ans_Init
#define bd_ans_IsQtagPacket e1000_ans_IsQtagPacket
#define bd_ans_ProcessRequest e1000_ans_ProcessRequest
#define bd_ans_Receive e1000_ans_Receive
#define bd_ans_ResetAllModes e1000_ans_ResetAllModes
#define bd_ans_SetReportingMode e1000_ans_SetReportingMode
#define bd_ans_TagGetCapability e1000_ans_TagGetCapability
#define bd_ans_TagSetMode e1000_ans_TagSetMode
#define bd_ans_Transmit e1000_ans_Transmit
#define bd_ans_VlanGetCapability e1000_ans_VlanGetCapability
#define bd_ans_VlanSetMode e1000_ans_VlanSetMode
#define bd_ans_VlanSetTable e1000_ans_VlanSetTable
#define bd_ans_drv_ConfigureTagging e1000_ans_drv_ConfigureTagging
#define bd_ans_drv_ConfigureVlan e1000_ans_drv_ConfigureVlan
#define bd_ans_drv_ConfigureVlanTable e1000_ans_drv_ConfigureVlanTable
#define bd_ans_drv_InitANS e1000_ans_drv_InitANS
#define bd_ans_drv_StartWatchdog e1000_ans_drv_StartWatchdog
#define bd_ans_drv_StopPromiscuousMode e1000_ans_drv_StopPromiscuousMode
#define bd_ans_drv_StopWatchdog e1000_ans_drv_StopWatchdog
#define bd_ans_drv_UpdateStatus e1000_ans_drv_UpdateStatus
#define bd_ans_hw_DisableTagging e1000_ans_hw_DisableTagging
#define bd_ans_hw_EnablePriorityRx e1000_ans_hw_EnablePriorityRx
#define bd_ans_hw_EnableVLAN e1000_ans_hw_EnableVLAN
#define bd_ans_hw_GetVlanId e1000_ans_hw_GetVlanId
#define bd_ans_hw_InsertQtagHW e1000_ans_hw_InsertQtagHW
#define bd_ans_hw_IsQtagPacket e1000_ans_hw_IsQtagPacket
#define bd_ans_hw_available_speeds e1000_ans_hw_available_speeds
#define bd_ans_os_AllocateTLV e1000_ans_os_AllocateTLV
#define bd_ans_os_AttributeFill e1000_ans_os_AttributeFill
#define bd_ans_os_InsertQtagSW e1000_ans_os_InsertQtagSW
#define bd_ans_os_Ioctl e1000_ans_os_Ioctl
#define bd_ans_os_Receive e1000_ans_os_Receive
#define bd_ans_os_ReserveSpaceForANS e1000_ans_os_ReserveSpaceForANS
#define bd_ans_os_SetCallback e1000_ans_os_SetCallback
#define bd_ans_os_StripQtagSW e1000_ans_os_StripQtagSW
#define bd_ans_os_Transmit e1000_ans_os_Transmit
#define bd_ans_os_Watchdog e1000_ans_os_Watchdog

#define IN
#define OUT
#define STATIC static

#include "e1000_fxhw.h"
#include "e1000_phy.h"

#ifdef IANS
#include "base_comm.h"
#include "ans_driver.h"
#include "ans.h"
#endif

#ifdef IDIAG
#include "idiag_pro.h"
#include "idiag_e1000.h"
#include "e1000_idiag.h"
#endif

#define PCI_DEVICE_ID_82542        0x1000
#define PCI_DEVICE_ID_82543GC_FIBER  0x1001
#define PCI_DEVICE_ID_82543GC_COPPER 0x1004
#define PCI_DEVICE_ID_82543PC_COPPER 0x1003
#define PCI_DEVICE_ID_82543PC_FIBER  0x1005
#define PCI_DEVICE_ID_82544EI_COPPER 0x1008
#define PCI_DEVICE_ID_82544EI_FIBER  0x1009
#define BAR_0 0

/* 8254x can use Dual Address Cycles for 64-bit addressing */
/* Advertise that we can DMA from any address location */
#define E1000_DMA_MASK (~0x0UL)
// #define E1000_DBG(S, args...) printk("e1000: " S "\n" , ## args)
#define E1000_DBG(S, args...)
#define E1000_ERR(S, args...) printk(KERN_ERR "e1000: " S "\n" , ## args)
#define E1000_MAX_INTR 10

#include <linux/init.h>
#include <linux/mm.h>
#include <linux/errno.h>
#include <linux/ioport.h>
#include <linux/pci.h>
#include <linux/kernel.h>
#include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include <linux/skbuff.h>
#include <linux/delay.h>
#include <linux/timer.h>
#include <linux/malloc.h>
#include <linux/interrupt.h>
#include <linux/string.h>
#include <asm/bitops.h>
#include <asm/io.h>
#include <asm/irq.h>
#include <linux/capability.h>
#include <linux/in.h>
#include <linux/ip.h>
#include <linux/tcp.h>
#include <linux/udp.h>

#define B_TRUE  1
#define B_FALSE 0
#define TRUE    1
#define FALSE   0

/* command line options defaults */
#define DEFAULT_TXD     256
#define MAX_TXD         256
#define MIN_TXD          80
#define DEFAULT_RXD     256
#define MAX_RXD         256
#define MIN_RXD          80
#define DEFAULT_TIDV     64
#define MAX_TIDV     0xFFFF
#define MIN_TIDV          0
#define DEFAULT_RIDV     64
#define MAX_RIDV     0xFFFF
#define MIN_RIDV          0

#define OPTION_UNSET    -1
#define OPTION_DISABLED 0
#define OPTION_ENABLED  1
#define JUMBO_DEFAULT        OPTION_ENABLED
#define XSUMRX_DEFAULT       OPTION_ENABLED
#define WAITFORLINK_DEFAULT  OPTION_ENABLED
#define AUTONEG_ADV_DEFAULT  0x2F
#define AUTONEG_ADV_MASK     0x2F
#define FLOW_CONTROL_DEFAULT FLOW_CONTROL_FULL

#define E1000_REPORT_TX_EARLY  2
#define E1000_PCI_MWI_ENABLE   1
#define E1000_PCI_MLT_OVERRIDE 0

/* Supported RX Buffer Sizes */
#define E1000_RXBUFFER_2048        2048
#define E1000_RXBUFFER_4096        4096
#define E1000_RXBUFFER_8192        8192
#define E1000_RXBUFFER_16384      16384

#define ETH_LENGTH_OF_ADDRESS 6

#define RET_STATUS_SUCCESS 0
#define RET_STATUS_FAILURE 1

#define E1000_PCI

/* The size in bytes of a standard ethernet header */
#define ENET_HEADER_SIZE    14
#define MAX_INTS            256
#define CRC_LENGTH 4

#define MAXIMUM_ETHERNET_PACKET_SIZE    1514
#define RCV_PKT_MUL              5

/* ROUNDUP macro */
#define E1000_ROUNDUP(size, unit) (unit * ((size + unit - 1) / unit))

/* wrapper around a pointer to a socket buffer,
 * so a DMA handle can be stored along with the buffer */
struct e1000_buffer {
    struct sk_buff *skb;
    dma_addr_t     dma;
    unsigned long  length;
};

/* Adapter->flags definitions */
#define E1000_BOARD_OPEN 0

typedef enum _XSUM_CONTEXT_T {
    OFFLOAD_NONE,
    OFFLOAD_TCP_IP,
    OFFLOAD_UDP_IP
} XSUM_CONTEXT_T;

/* board specific private data structure */
struct _ADAPTER_STRUCT {
#ifdef IANS
    void *iANSReserved;
    piANSsupport_t iANSdata;
    UINT32 ans_link;
    UINT32 ans_speed;
    UINT32 ans_duplex;
    UINT32 ans_suspend;
    IANS_BD_TAGGING_MODE tag_mode;
#endif

#ifdef IDIAG
    BOOLEAN IntrTestInProgress;
    UINT32 IntrCount;
#endif

    struct _ADAPTER_STRUCT *next;
    struct _ADAPTER_STRUCT *prev;

    uint32_t flags;
    uint32_t bd_number;
    struct timer_list timer_id;
    uint32_t tx_out_res;

    /* used by Intel gigabit shared MAC/Phy code - DO NOT CHANGE */
    /* MMIO PCI Registers */
    PE1000_REGISTERS HardwareVirtualAddress;
    /* Ethernet Node Address */
    uint8_t CurrentNetAddress[ETH_LENGTH_OF_ADDRESS];
    uint8_t PermNetAddress[ETH_LENGTH_OF_ADDRESS];

    /* Mac and Phy Settings */
    uint8_t MacType;
    uint8_t MediaType;
    uint32_t PhyId;
    uint32_t PhyAddress;

    /* MAC Configuration */
    uint8_t AutoNeg;
    uint8_t ForcedSpeedDuplex;
    uint16_t AutoNegAdvertised;
    uint8_t WaitAutoNegComplete;

    /* Status Flags */
    BOOLEAN LinkIsActive;
    uint16_t LineSpeed;
    uint16_t FullDuplex;
    BOOLEAN GetLinkStatus;
    BOOLEAN LinkStatusChanged;
    BOOLEAN LongPacket;
    uint32_t RxBufferLen;
    BOOLEAN TbiCompatibilityEnable;
    BOOLEAN TbiCompatibilityOn;

    /* PCI Device Info */
    uint16_t VendorId;
    uint16_t DeviceId;
    uint8_t RevId;
    uint16_t SubVendorId;
    uint16_t SubSystemId;

    UINT32 PartNumber;

    uint32_t MulticastFilterType;
    BOOLEAN AdapterStopped;
    uint16_t PciCommandWord;
    uint8_t DmaFairness;
    uint32_t OriginalFlowControl;
    uint8_t FlowControl;
    uint16_t FlowControlHighWatermark;
    uint16_t FlowControlLowWatermark;
    uint16_t FlowControlPauseTime;
    BOOLEAN FlowControlSendXon;
    BOOLEAN ReportTxEarly;
    uint32_t TxcwRegValue;
    uint32_t AutoNegFailed;

    /* e1000_adaptive */
    BOOLEAN AdaptiveTxThreshold;
    UINT32 CurrentTxThreshold;
    UINT8 TxThresholdTimer;
    BOOLEAN AdaptiveIFS;
    BOOLEAN InIFSMode;
    BOOLEAN IFSParamsForced;
    UINT16 CurrentIFSValue;
    UINT16 IFSMaxValue;
    UINT16 IFSMinValue;
    UINT16 IFSStepSize;
    UINT16 IFSRatio;

    /* driver specific */
    struct tasklet_struct rx_fill_tasklet;

    int NumTxDescriptors;
    uint32_t TxIntDelay;
    int NextAvailTxDescriptor;
    int OldestUsedTxDescriptor;
    E1000_TRANSMIT_DESCRIPTOR *TxDescriptors;
    dma_addr_t TxDescDMA;
    struct e1000_buffer *tx_skb;
    atomic_t NumTxDescriptorsAvail;
    uint32_t TxdCmd;

    int NumRxDescriptors;
    uint32_t RxIntDelay;
    int NextRxDescriptorToCheck;
    E1000_RECEIVE_DESCRIPTOR *RxDescriptors;
    dma_addr_t RxDescDMA;
    struct e1000_buffer *rx_skb;
    atomic_t NumRxDescriptorsEmpty;
    int NextRxDescriptorToFill;

    uint64_t XsumRXGood;
    uint64_t XsumRXError;
    
    /* Linux driver specific */
    struct net_device *netdev;
    struct pci_dev *pdev;
    struct net_device_stats net_stats;
    char *id_string;
    uint8_t JumboFrames;
    uint8_t RxChecksum;
    XSUM_CONTEXT_T ActiveChecksumContext;

    /* Statistic Registers Dump */
    uint64_t Crcerrs;  /* rx crc error count               */
    uint64_t Algnerrc; /* alignment error count (LG)       */
    uint64_t Symerrs;  /* rx symbol error count            */
    uint64_t Rxerrc;   /* RX_ERROR count (LG) - PHY detected rx errors */
    uint64_t Mpc;      /* Missed Packet Count - packets dropped due to full rx fifo */
    uint64_t Scc;     /* single collision count           */
    uint64_t Ecol;    /* excessive collision count        */
    uint64_t Mcc;     /* multiple collision count         */
    uint64_t Latecol; /* late collision count             */
    uint64_t Colc;    /* Total collision count            */
    uint64_t Tuc;     /* transmit underrun count (LG)     */
    uint64_t Dc;      /* tx defer count due               */
    uint64_t Tncrs;   /* transmit no CRS count (LG)       */
    uint64_t Sec;     /* rx sequence error count          */
    uint64_t Cexterr; /* carrier ext error count (LG)     */
    uint64_t Rlec;    /* receive length error count       */
    uint64_t Rutec;   /* receive DMA to early count (LG)  */
    uint64_t Xonrxc;  /* XON received count               */
    uint64_t Xontxc;  /* XON transmitted count            */
    uint64_t Xoffrxc; /* XOFF received count              */
    uint64_t Xofftxc; /* XOFF transmitted count           */
    uint64_t Fcruc;   /* unknown Flow Control packet rcved count */
    uint64_t Prc64;   /* packets received (64 Bytes)      */
    uint64_t Prc127;  /* packets received (65-127)        */
    uint64_t Prc255;  /* packets received (128-255)       */
    uint64_t Prc511;  /* packets received (256-511)       */
    uint64_t Prc1023; /* packets received (512-1023)      */
    uint64_t Prc1522; /* packets received (1024+)         */
    uint64_t Gprc;    /* Good packets received count      */
    uint64_t Bprc;    /* Broadcasts pkts recvd count      */
    uint64_t Mprc;    /* Multicast  pkts recvd count      */
    uint64_t Gptc;    /* Good packets xmited count        */
    uint64_t Gor;     /* Good octets recvd                */
    uint64_t Got;     /* Good octets xmitd                */
    uint64_t Rnbc;    /* Receive no buffers count         */
    uint64_t Ruc;     /* Receive undersize count          */
    uint64_t Rfc;     /* Receive fragment count           */
    uint64_t Roc;     /* Receive oversize count           */
    uint64_t Rjc;     /* Receive jabber count             */
    uint64_t Tor;     /* Total octets recvd               */
    uint64_t Tot;     /* Total octets xmitd               */
    uint64_t Tpr;     /* Total packets received           */
    uint64_t Tpt;     /* Total packets xmitted            */
    uint64_t Ptc64;   /* packets xmitted (64B)            */
    uint64_t Ptc127;  /* packets xmitted (64-127)         */
    uint64_t Ptc255;  /* packets xmitted (128-255)        */
    uint64_t Ptc511;  /* packets xmitted (256-511)        */
    uint64_t Ptc1023; /* packets xmitted (512-1023)       */
    uint64_t Ptc1522; /* packets xmitted (1024-1522)      */
    uint64_t Mptc;    /* Multicast  pkts xmit count       */
    uint64_t Bptc;    /* Broadcasts pkts xmit count       */

};

/* PCI defines needed by e1000_fxhw.c */
/* define these using the Linux names for the same thing (pci.h) */
#define CMD_MEM_WRT_INVALIDATE PCI_COMMAND_INVALIDATE
#define PCI_COMMAND_REGISTER PCI_COMMAND

/* Prototypes */
/* e1000_main.c */
extern int e1000_init_module(void);
extern int e1000_probe_all(void);
extern void e1000_exit_module(void);
extern int e1000_probe(struct pci_dev *pdev,
                                 const struct pci_device_id *ent);
extern void e1000_remove(struct pci_dev *pdev);
extern void e1000_delete(PADAPTER_STRUCT Adapter);
extern int e1000_open(struct net_device *netdev);
extern int e1000_close(struct net_device *netdev);
extern void e1000_set_multi(struct net_device *netdev);
extern int e1000_xmit_frame(struct sk_buff *skb, struct net_device *netdev);
extern struct net_device_stats *e1000_get_stats(struct net_device *netdev);
extern int e1000_change_mtu(struct net_device *netdev, int new_mtu);
extern int e1000_set_mac(struct net_device *netdev, void *p);
extern void e1000_intr(int irq, void *data, struct pt_regs *regs);
extern int e1000_ioctl(struct net_device *netdev,
                          struct ifreq *ifr, int cmd);
extern void e1000_watchdog(unsigned long data);

/* e1000_fxhw.c */
extern VOID AdapterStop(PADAPTER_STRUCT Adapter);
extern BOOLEAN InitializeHardware(PADAPTER_STRUCT Adapter);
extern VOID InitRxAddresses(PADAPTER_STRUCT Adapter);
extern BOOLEAN SetupFlowControlAndLink(PADAPTER_STRUCT Adapter);
extern BOOLEAN SetupPcsLink(PADAPTER_STRUCT Adapter, UINT32 DeviceControlReg);
extern VOID ConfigFlowControlAfterLinkUp(PADAPTER_STRUCT Adapter);
extern VOID ForceMacFlowControlSetting(PADAPTER_STRUCT Adapter);
extern VOID CheckForLink(PADAPTER_STRUCT Adapter);
extern VOID ClearHwStatsCounters(PADAPTER_STRUCT Adapter);
extern VOID GetSpeedAndDuplex(PADAPTER_STRUCT Adapter,
                              PUINT16 Speed, PUINT16 Duplex);
extern USHORT ReadEepromWord(PADAPTER_STRUCT Adapter, USHORT Reg);
extern BOOLEAN ValidateEepromChecksum(PADAPTER_STRUCT Adapter);
extern VOID UpdateEepromChecksum(PADAPTER_STRUCT Adapter);
extern BOOLEAN WriteEepromWord(PADAPTER_STRUCT Adapter,
                               USHORT Reg, USHORT Data);
extern BOOLEAN ReadPartNumber(PADAPTER_STRUCT Adapter, UINT32 *PartNumber);
extern VOID IdLedOn(PADAPTER_STRUCT Adapter);
extern VOID IdLedOff(PADAPTER_STRUCT Adapter);

/* e1000_phy.h */
extern UINT16 ReadPhyRegister(PADAPTER_STRUCT Adapter,
                              UINT32 RegAddress, UINT32 PhyAddress);

/*  #include "e1000_adaptive.h" */
#include "e1000_proc.h"
#endif /* _E1000_H_ */
